diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/template.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/template.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/template.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 166,175 ****
   * @return array List of popular term IDs.
   */
  function wp_popular_terms_checklist( $taxonomy, $default = 0, $number = 10, $echo = true ) {
! 	global $post_ID;
  
! 	if ( $post_ID )
! 		$checked_terms = wp_get_object_terms($post_ID, $taxonomy, array('fields'=>'ids'));
  	else
  		$checked_terms = array();
  
--- 166,175 ----
   * @return array List of popular term IDs.
   */
  function wp_popular_terms_checklist( $taxonomy, $default = 0, $number = 10, $echo = true ) {
! 	$post = get_post();
  
! 	if ( $post && $post->ID )
! 		$checked_terms = wp_get_object_terms($post->ID, $taxonomy, array('fields'=>'ids'));
  	else
  		$checked_terms = array();
  
***************
*** 332,348 ****
  	<div id="edithead" style="display:none;">
  		<div class="inside">
  		<label for="author"><?php _e('Name') ?></label>
! 		<input type="text" name="newcomment_author" size="50" value="" tabindex="101" id="author" />
  		</div>
  
  		<div class="inside">
  		<label for="author-email"><?php _e('E-mail') ?></label>
! 		<input type="text" name="newcomment_author_email" size="50" value="" tabindex="102" id="author-email" />
  		</div>
  
  		<div class="inside">
  		<label for="author-url"><?php _e('URL') ?></label>
! 		<input type="text" id="author-url" name="newcomment_author_url" size="103" value="" tabindex="103" />
  		</div>
  		<div style="clear:both;"></div>
  	</div>
--- 332,348 ----
  	<div id="edithead" style="display:none;">
  		<div class="inside">
  		<label for="author"><?php _e('Name') ?></label>
! 		<input type="text" name="newcomment_author" size="50" value="" id="author" />
  		</div>
  
  		<div class="inside">
  		<label for="author-email"><?php _e('E-mail') ?></label>
! 		<input type="text" name="newcomment_author_email" size="50" value="" id="author-email" />
  		</div>
  
  		<div class="inside">
  		<label for="author-url"><?php _e('URL') ?></label>
! 		<input type="text" id="author-url" name="newcomment_author_url" size="103" value="" />
  		</div>
  		<div style="clear:both;"></div>
  	</div>
***************
*** 350,366 ****
  	<div id="replycontainer">
  	<?php
  	$quicktags_settings = array( 'buttons' => 'strong,em,link,block,del,ins,img,ul,ol,li,code,spell,close' );
! 	wp_editor( '', 'replycontent', array( 'media_buttons' => false, 'tinymce' => false, 'quicktags' => $quicktags_settings, 'tabindex' => 104 ) );
  	?>
  	</div>
  
  	<p id="replysubmit" class="submit">
! 	<a href="#comments-form" class="cancel button-secondary alignleft" tabindex="106"><?php _e('Cancel'); ?></a>
! 	<a href="#comments-form" class="save button-primary alignright" tabindex="104">
  	<span id="addbtn" style="display:none;"><?php _e('Add Comment'); ?></span>
  	<span id="savebtn" style="display:none;"><?php _e('Update Comment'); ?></span>
  	<span id="replybtn" style="display:none;"><?php _e('Submit Reply'); ?></span></a>
! 	<img class="waiting" style="display:none;" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
  	<span class="error" style="display:none;"></span>
  	<br class="clear" />
  	</p>
--- 350,366 ----
  	<div id="replycontainer">
  	<?php
  	$quicktags_settings = array( 'buttons' => 'strong,em,link,block,del,ins,img,ul,ol,li,code,spell,close' );
! 	wp_editor( '', 'replycontent', array( 'media_buttons' => false, 'tinymce' => false, 'quicktags' => $quicktags_settings ) );
  	?>
  	</div>
  
  	<p id="replysubmit" class="submit">
! 	<a href="#comments-form" class="save button-primary alignright">
  	<span id="addbtn" style="display:none;"><?php _e('Add Comment'); ?></span>
  	<span id="savebtn" style="display:none;"><?php _e('Update Comment'); ?></span>
  	<span id="replybtn" style="display:none;"><?php _e('Submit Reply'); ?></span></a>
! 	<a href="#comments-form" class="cancel button-secondary alignleft"><?php _e('Cancel'); ?></a>
! 	<span class="waiting spinner"></span>
  	<span class="error" style="display:none;"></span>
  	<br class="clear" />
  	</p>
***************
*** 421,427 ****
  		<th>' . __( 'Value' ) . '</th>
  	</tr>
  	</thead>
! 	<tbody id="the-list" class="list:meta">
  	<tr><td></td></tr>
  	</tbody>
  </table>'; //TBODY needed for list-manipulation JS
--- 421,427 ----
  		<th>' . __( 'Value' ) . '</th>
  	</tr>
  	</thead>
! 	<tbody id="the-list" data-wp-lists="list:meta">
  	<tr><td></td></tr>
  	</tbody>
  </table>'; //TBODY needed for list-manipulation JS
***************
*** 436,442 ****
  		<th><?php _e( 'Value' ) ?></th>
  	</tr>
  	</thead>
! 	<tbody id='the-list' class='list:meta'>
  <?php
  	foreach ( $meta as $entry )
  		echo _list_meta_row( $entry, $count );
--- 436,442 ----
  		<th><?php _e( 'Value' ) ?></th>
  	</tr>
  	</thead>
! 	<tbody id='the-list' data-wp-lists='list:meta'>
  <?php
  	foreach ( $meta as $entry )
  		echo _list_meta_row( $entry, $count );
***************
*** 489,505 ****
  	$delete_nonce = wp_create_nonce( 'delete-meta_' . $entry['meta_id'] );
  
  	$r .= "\n\t<tr id='meta-{$entry['meta_id']}' class='$style'>";
! 	$r .= "\n\t\t<td class='left'><label class='screen-reader-text' for='meta[{$entry['meta_id']}][key]'>" . __( 'Key' ) . "</label><input name='meta[{$entry['meta_id']}][key]' id='meta[{$entry['meta_id']}][key]' tabindex='6' type='text' size='20' value='{$entry['meta_key']}' />";
  
  	$r .= "\n\t\t<div class='submit'>";
! 	$r .= get_submit_button( __( 'Delete' ), "delete:the-list:meta-{$entry['meta_id']}::_ajax_nonce=$delete_nonce deletemeta", "deletemeta[{$entry['meta_id']}]", false, array( 'tabindex' => '6' ) );
  	$r .= "\n\t\t";
! 	$r .= get_submit_button( __( 'Update' ), "add:the-list:meta-{$entry['meta_id']}::_ajax_nonce-add-meta=$update_nonce updatemeta" , 'updatemeta', false, array( 'tabindex' => '6' ) );
  	$r .= "</div>";
  	$r .= wp_nonce_field( 'change-meta', '_ajax_nonce', false, false );
  	$r .= "</td>";
  
! 	$r .= "\n\t\t<td><label class='screen-reader-text' for='meta[{$entry['meta_id']}][value]'>" . __( 'Value' ) . "</label><textarea name='meta[{$entry['meta_id']}][value]' id='meta[{$entry['meta_id']}][value]' tabindex='6' rows='2' cols='30'>{$entry['meta_value']}</textarea></td>\n\t</tr>";
  	return $r;
  }
  
--- 489,505 ----
  	$delete_nonce = wp_create_nonce( 'delete-meta_' . $entry['meta_id'] );
  
  	$r .= "\n\t<tr id='meta-{$entry['meta_id']}' class='$style'>";
! 	$r .= "\n\t\t<td class='left'><label class='screen-reader-text' for='meta[{$entry['meta_id']}][key]'>" . __( 'Key' ) . "</label><input name='meta[{$entry['meta_id']}][key]' id='meta[{$entry['meta_id']}][key]' type='text' size='20' value='{$entry['meta_key']}' />";
  
  	$r .= "\n\t\t<div class='submit'>";
! 	$r .= get_submit_button( __( 'Delete' ), 'deletemeta small', "deletemeta[{$entry['meta_id']}]", false, array( 'data-wp-lists' => "delete:the-list:meta-{$entry['meta_id']}::_ajax_nonce=$delete_nonce" ) );
  	$r .= "\n\t\t";
! 	$r .= get_submit_button( __( 'Update' ), 'updatemeta small', "meta-{$entry['meta_id']}-submit", false, array( 'data-wp-lists' => "add:the-list:meta-{$entry['meta_id']}::_ajax_nonce-add-meta=$update_nonce" ) );
  	$r .= "</div>";
  	$r .= wp_nonce_field( 'change-meta', '_ajax_nonce', false, false );
  	$r .= "</td>";
  
! 	$r .= "\n\t\t<td><label class='screen-reader-text' for='meta[{$entry['meta_id']}][value]'>" . __( 'Value' ) . "</label><textarea name='meta[{$entry['meta_id']}][value]' id='meta[{$entry['meta_id']}][value]' rows='2' cols='30'>{$entry['meta_value']}</textarea></td>\n\t</tr>";
  	return $r;
  }
  
***************
*** 534,540 ****
  <tr>
  <td id="newmetaleft" class="left">
  <?php if ( $keys ) { ?>
! <select id="metakeyselect" name="metakeyselect" tabindex="7">
  <option value="#NONE#"><?php _e( '&mdash; Select &mdash;' ); ?></option>
  <?php
  
--- 534,540 ----
  <tr>
  <td id="newmetaleft" class="left">
  <?php if ( $keys ) { ?>
! <select id="metakeyselect" name="metakeyselect">
  <option value="#NONE#"><?php _e( '&mdash; Select &mdash;' ); ?></option>
  <?php
  
***************
*** 543,561 ****
  	}
  ?>
  </select>
! <input class="hide-if-js" type="text" id="metakeyinput" name="metakeyinput" tabindex="7" value="" />
  <a href="#postcustomstuff" class="hide-if-no-js" onclick="jQuery('#metakeyinput, #metakeyselect, #enternew, #cancelnew').toggle();return false;">
  <span id="enternew"><?php _e('Enter new'); ?></span>
  <span id="cancelnew" class="hidden"><?php _e('Cancel'); ?></span></a>
  <?php } else { ?>
! <input type="text" id="metakeyinput" name="metakeyinput" tabindex="7" value="" />
  <?php } ?>
  </td>
! <td><textarea id="metavalue" name="metavalue" rows="2" cols="25" tabindex="8"></textarea></td>
  </tr>
  
! <tr><td colspan="2" class="submit">
! <?php submit_button( __( 'Add Custom Field' ), 'add:the-list:newmeta', 'addmeta', false, array( 'id' => 'addmetasub', 'tabindex' => '9' ) ); ?>
  <?php wp_nonce_field( 'add-meta', '_ajax_nonce-add-meta', false ); ?>
  </td></tr>
  </tbody>
--- 543,563 ----
  	}
  ?>
  </select>
! <input class="hide-if-js" type="text" id="metakeyinput" name="metakeyinput" value="" />
  <a href="#postcustomstuff" class="hide-if-no-js" onclick="jQuery('#metakeyinput, #metakeyselect, #enternew, #cancelnew').toggle();return false;">
  <span id="enternew"><?php _e('Enter new'); ?></span>
  <span id="cancelnew" class="hidden"><?php _e('Cancel'); ?></span></a>
  <?php } else { ?>
! <input type="text" id="metakeyinput" name="metakeyinput" value="" />
  <?php } ?>
  </td>
! <td><textarea id="metavalue" name="metavalue" rows="2" cols="25"></textarea></td>
  </tr>
  
! <tr><td colspan="2">
! <div class="submit">
! <?php submit_button( __( 'Add Custom Field' ), 'secondary', 'addmeta', false, array( 'id' => 'newmeta-submit', 'data-wp-lists' => 'add:the-list:newmeta' ) ); ?>
! </div>
  <?php wp_nonce_field( 'add-meta', '_ajax_nonce-add-meta', false ); ?>
  </td></tr>
  </tbody>
***************
*** 575,581 ****
   * @param unknown_type $multi
   */
  function touch_time( $edit = 1, $for_post = 1, $tab_index = 0, $multi = 0 ) {
! 	global $wp_locale, $post, $comment;
  
  	if ( $for_post )
  		$edit = ! ( in_array($post->post_status, array('draft', 'pending') ) && (!$post->post_date_gmt || '0000-00-00 00:00:00' == $post->post_date_gmt ) );
--- 577,584 ----
   * @param unknown_type $multi
   */
  function touch_time( $edit = 1, $for_post = 1, $tab_index = 0, $multi = 0 ) {
! 	global $wp_locale, $comment;
! 	$post = get_post();
  
  	if ( $for_post )
  		$edit = ! ( in_array($post->post_status, array('draft', 'pending') ) && (!$post->post_date_gmt || '0000-00-00 00:00:00' == $post->post_date_gmt ) );
***************
*** 670,686 ****
   * @return unknown
   */
  function parent_dropdown( $default = 0, $parent = 0, $level = 0 ) {
! 	global $wpdb, $post_ID;
  	$items = $wpdb->get_results( $wpdb->prepare("SELECT ID, post_parent, post_title FROM $wpdb->posts WHERE post_parent = %d AND post_type = 'page' ORDER BY menu_order", $parent) );
  
  	if ( $items ) {
  		foreach ( $items as $item ) {
  			// A page cannot be its own parent.
! 			if (!empty ( $post_ID ) ) {
! 				if ( $item->ID == $post_ID ) {
! 					continue;
! 				}
! 			}
  			$pad = str_repeat( '&nbsp;', $level * 3 );
  			if ( $item->ID == $default)
  				$current = ' selected="selected"';
--- 673,688 ----
   * @return unknown
   */
  function parent_dropdown( $default = 0, $parent = 0, $level = 0 ) {
! 	global $wpdb;
! 	$post = get_post();
  	$items = $wpdb->get_results( $wpdb->prepare("SELECT ID, post_parent, post_title FROM $wpdb->posts WHERE post_parent = %d AND post_type = 'page' ORDER BY menu_order", $parent) );
  
  	if ( $items ) {
  		foreach ( $items as $item ) {
  			// A page cannot be its own parent.
! 			if ( $post->ID && $item->ID == $post->ID )
! 				continue;
! 
  			$pad = str_repeat( '&nbsp;', $level * 3 );
  			if ( $item->ID == $default)
  				$current = ' selected="selected"';
***************
*** 705,711 ****
   */
  function the_attachment_links( $id = false ) {
  	$id = (int) $id;
! 	$post = & get_post( $id );
  
  	if ( $post->post_type != 'attachment' )
  		return false;
--- 707,713 ----
   */
  function the_attachment_links( $id = false ) {
  	$id = (int) $id;
! 	$post = get_post( $id );
  
  	if ( $post->post_type != 'attachment' )
  		return false;
***************
*** 770,825 ****
  }
  
  /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 2.3.0
-  *
-  * @param unknown_type $size
-  * @return unknown
-  */
- function wp_convert_hr_to_bytes( $size ) {
- 	$size = strtolower($size);
- 	$bytes = (int) $size;
- 	if ( strpos($size, 'k') !== false )
- 		$bytes = intval($size) * 1024;
- 	elseif ( strpos($size, 'm') !== false )
- 		$bytes = intval($size) * 1024 * 1024;
- 	elseif ( strpos($size, 'g') !== false )
- 		$bytes = intval($size) * 1024 * 1024 * 1024;
- 	return $bytes;
- }
- 
- /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 2.3.0
-  *
-  * @param unknown_type $bytes
-  * @return unknown
-  */
- function wp_convert_bytes_to_hr( $bytes ) {
- 	$units = array( 0 => 'B', 1 => 'kB', 2 => 'MB', 3 => 'GB' );
- 	$log = log( $bytes, 1024 );
- 	$power = (int) $log;
- 	$size = pow(1024, $log - $power);
- 	return $size . $units[$power];
- }
- 
- /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 2.5.0
-  *
-  * @return unknown
-  */
- function wp_max_upload_size() {
- 	$u_bytes = wp_convert_hr_to_bytes( ini_get( 'upload_max_filesize' ) );
- 	$p_bytes = wp_convert_hr_to_bytes( ini_get( 'post_max_size' ) );
- 	$bytes = apply_filters( 'upload_size_limit', min($u_bytes, $p_bytes), $u_bytes, $p_bytes );
- 	return $bytes;
- }
- 
- /**
   * Outputs the form used by the importers to accept the data to be imported
   *
   * @since 2.0.0
--- 772,777 ----
***************
*** 835,841 ****
  		<p><strong><?php echo $upload_dir['error']; ?></strong></p></div><?php
  	else :
  ?>
! <form enctype="multipart/form-data" id="import-upload-form" method="post" action="<?php echo esc_attr(wp_nonce_url($action, 'import-upload')); ?>">
  <p>
  <label for="upload"><?php _e( 'Choose a file from your computer:' ); ?></label> (<?php printf( __('Maximum size: %s' ), $size ); ?>)
  <input type="file" id="upload" name="import" size="25" />
--- 787,793 ----
  		<p><strong><?php echo $upload_dir['error']; ?></strong></p></div><?php
  	else :
  ?>
! <form enctype="multipart/form-data" id="import-upload-form" method="post" class="wp-upload-form" action="<?php echo esc_attr(wp_nonce_url($action, 'import-upload')); ?>">
  <p>
  <label for="upload"><?php _e( 'Choose a file from your computer:' ); ?></label> (<?php printf( __('Maximum size: %s' ), $size ); ?>)
  <input type="file" id="upload" name="import" size="25" />
***************
*** 1040,1049 ****
  	global $wp_settings_sections;
  
  	if ( 'misc' == $page ) {
! 		_deprecated_argument( __FUNCTION__, '3.0', __( 'The miscellaneous options group has been removed. Use another settings group.' ) );
  		$page = 'general';
  	}
  
  	if ( !isset($wp_settings_sections) )
  		$wp_settings_sections = array();
  	if ( !isset($wp_settings_sections[$page]) )
--- 992,1006 ----
  	global $wp_settings_sections;
  
  	if ( 'misc' == $page ) {
! 		_deprecated_argument( __FUNCTION__, '3.0', sprintf( __( 'The "%s" options group has been removed. Use another settings group.' ), 'misc' ) );
  		$page = 'general';
  	}
  
+ 	if ( 'privacy' == $page ) {
+ 		_deprecated_argument( __FUNCTION__, '3.5', sprintf( __( 'The "%s" options group has been removed. Use another settings group.' ), 'privacy' ) );
+ 		$page = 'reading';
+ 	}
+ 
  	if ( !isset($wp_settings_sections) )
  		$wp_settings_sections = array();
  	if ( !isset($wp_settings_sections[$page]) )
***************
*** 1084,1089 ****
--- 1041,1051 ----
  		$page = 'general';
  	}
  
+ 	if ( 'privacy' == $page ) {
+ 		_deprecated_argument( __FUNCTION__, '3.5', __( 'The privacy options group has been removed. Use another settings group.' ) );
+ 		$page = 'reading';
+ 	}
+ 
  	if ( !isset($wp_settings_fields) )
  		$wp_settings_fields = array();
  	if ( !isset($wp_settings_fields[$page]) )
***************
*** 1107,1126 ****
   *
   * @param string $page The slug name of the page whos settings sections you want to output
   */
! function do_settings_sections($page) {
  	global $wp_settings_sections, $wp_settings_fields;
  
! 	if ( !isset($wp_settings_sections) || !isset($wp_settings_sections[$page]) )
  		return;
  
  	foreach ( (array) $wp_settings_sections[$page] as $section ) {
  		if ( $section['title'] )
  			echo "<h3>{$section['title']}</h3>\n";
! 		call_user_func($section['callback'], $section);
! 		if ( !isset($wp_settings_fields) || !isset($wp_settings_fields[$page]) || !isset($wp_settings_fields[$page][$section['id']]) )
  			continue;
  		echo '<table class="form-table">';
! 		do_settings_fields($page, $section['id']);
  		echo '</table>';
  	}
  }
--- 1069,1091 ----
   *
   * @param string $page The slug name of the page whos settings sections you want to output
   */
! function do_settings_sections( $page ) {
  	global $wp_settings_sections, $wp_settings_fields;
  
! 	if ( ! isset( $wp_settings_sections ) || !isset( $wp_settings_sections[$page] ) )
  		return;
  
  	foreach ( (array) $wp_settings_sections[$page] as $section ) {
  		if ( $section['title'] )
  			echo "<h3>{$section['title']}</h3>\n";
! 
! 		if ( $section['callback'] )
! 			call_user_func( $section['callback'], $section );
! 
! 		if ( ! isset( $wp_settings_fields ) || !isset( $wp_settings_fields[$page] ) || !isset( $wp_settings_fields[$page][$section['id']] ) )
  			continue;
  		echo '<table class="form-table">';
! 		do_settings_fields( $page, $section['id'] );
  		echo '</table>';
  	}
  }
***************
*** 1148,1154 ****
  	foreach ( (array) $wp_settings_fields[$page][$section] as $field ) {
  		echo '<tr valign="top">';
  		if ( !empty($field['args']['label_for']) )
! 			echo '<th scope="row"><label for="' . $field['args']['label_for'] . '">' . $field['title'] . '</label></th>';
  		else
  			echo '<th scope="row">' . $field['title'] . '</th>';
  		echo '<td>';
--- 1113,1119 ----
  	foreach ( (array) $wp_settings_fields[$page][$section] as $field ) {
  		echo '<tr valign="top">';
  		if ( !empty($field['args']['label_for']) )
! 			echo '<th scope="row"><label for="' . esc_attr( $field['args']['label_for'] ) . '">' . $field['title'] . '</label></th>';
  		else
  			echo '<th scope="row">' . $field['title'] . '</th>';
  		echo '<td>';
***************
*** 1224,1250 ****
  	// This allows the $sanitize_callback from register_setting() to run, adding
  	// any settings errors you want to show by default.
  	if ( $sanitize )
! 		sanitize_option( $setting, get_option($setting));
  
  	// If settings were passed back from options.php then use them
! 	// Ignore transients if $sanitize is true, we don't want the old values anyway
! 	if ( isset($_GET['settings-updated']) && $_GET['settings-updated'] && get_transient('settings_errors') ) {
! 		$settings_errors = get_transient('settings_errors');
! 		delete_transient('settings_errors');
! 	// Otherwise check global in case validation has been run on this pageload
! 	} elseif ( count( $wp_settings_errors ) ) {
! 		$settings_errors = $wp_settings_errors;
! 	} else {
! 		return;
  	}
  
  	// Filter the results to those of a specific setting if one was set
  	if ( $setting ) {
! 		foreach ( (array) $settings_errors as $key => $details )
! 			if ( $setting != $details['setting'] )
! 				unset( $settings_errors[$key] );
  	}
! 	return $settings_errors;
  }
  
  /**
--- 1189,1217 ----
  	// This allows the $sanitize_callback from register_setting() to run, adding
  	// any settings errors you want to show by default.
  	if ( $sanitize )
! 		sanitize_option( $setting, get_option( $setting ) );
  
  	// If settings were passed back from options.php then use them
! 	if ( isset( $_GET['settings-updated'] ) && $_GET['settings-updated'] && get_transient( 'settings_errors' ) ) {
! 		$wp_settings_errors = array_merge( (array) $wp_settings_errors, get_transient( 'settings_errors' ) );
! 		delete_transient( 'settings_errors' );
  	}
  
+ 	// Check global in case errors have been added on this pageload
+ 	if ( ! count( $wp_settings_errors ) )
+ 		return array();
+ 
  	// Filter the results to those of a specific setting if one was set
  	if ( $setting ) {
! 		$setting_errors = array();
! 		foreach ( (array) $wp_settings_errors as $key => $details ) {
! 			if ( $setting == $details['setting'] )
! 				$setting_errors[] = $wp_settings_errors[$key];
! 		}
! 		return $setting_errors;
  	}
! 
! 	return $wp_settings_errors;
  }
  
  /**
***************
*** 1276,1282 ****
  
  	$settings_errors = get_settings_errors( $setting, $sanitize );
  
! 	if ( ! is_array( $settings_errors ) )
  		return;
  
  	$output = '';
--- 1243,1249 ----
  
  	$settings_errors = get_settings_errors( $setting, $sanitize );
  
! 	if ( empty( $settings_errors ) )
  		return;
  
  	$output = '';
***************
*** 1311,1328 ****
  				<?php wp_nonce_field( 'find-posts', '_ajax_nonce', false ); ?>
  				<label class="screen-reader-text" for="find-posts-input"><?php _e( 'Search' ); ?></label>
  				<input type="text" id="find-posts-input" name="ps" value="" />
! 				<input type="button" id="find-posts-search" value="<?php esc_attr_e( 'Search' ); ?>" class="button" /><br />
! 
! 				<?php
! 				$post_types = get_post_types( array('public' => true), 'objects' );
! 				foreach ( $post_types as $post ) {
! 					if ( 'attachment' == $post->name )
! 						continue;
! 				?>
! 				<input type="radio" name="find-posts-what" id="find-posts-<?php echo esc_attr($post->name); ?>" value="<?php echo esc_attr($post->name); ?>" <?php checked($post->name, 'post'); ?> />
! 				<label for="find-posts-<?php echo esc_attr($post->name); ?>"><?php echo $post->label; ?></label>
! 				<?php
! 				} ?>
  			</div>
  			<div id="find-posts-response"></div>
  		</div>
--- 1278,1285 ----
  				<?php wp_nonce_field( 'find-posts', '_ajax_nonce', false ); ?>
  				<label class="screen-reader-text" for="find-posts-input"><?php _e( 'Search' ); ?></label>
  				<input type="text" id="find-posts-input" name="ps" value="" />
! 				<span class="spinner"></span>
! 				<input type="button" id="find-posts-search" value="<?php esc_attr_e( 'Search' ); ?>" class="button" />
  			</div>
  			<div id="find-posts-response"></div>
  		</div>
***************
*** 1344,1351 ****
   * @since 2.7.0
   */
  function the_post_password() {
! 	global $post;
! 	if ( isset( $post->post_password ) ) echo esc_attr( $post->post_password );
  }
  
  /**
--- 1301,1309 ----
   * @since 2.7.0
   */
  function the_post_password() {
! 	$post = get_post();
! 	if ( isset( $post->post_password ) )
! 		echo esc_attr( $post->post_password );
  }
  
  /**
***************
*** 1355,1367 ****
   * returned.
   *
   * @since 2.7.0
!  * @param int $post_id The post id. If not supplied the global $post is used.
   * @return string The post title if set
   */
! function _draft_or_post_title( $post_id = 0 ) {
! 	$title = get_the_title($post_id);
! 	if ( empty($title) )
! 		$title = __('(no title)');
  	return $title;
  }
  
--- 1313,1325 ----
   * returned.
   *
   * @since 2.7.0
!  * @param mixed $post Post id or object. If not supplied the global $post is used.
   * @return string The post title if set
   */
! function _draft_or_post_title( $post = 0 ) {
! 	$title = get_the_title( $post );
! 	if ( empty( $title ) )
! 		$title = __( '(no title)' );
  	return $title;
  }
  
***************
*** 1394,1399 ****
--- 1352,1358 ----
  
  	$current_screen = get_current_screen();
  
+ 	@header( 'Content-Type: ' . get_option( 'html_type' ) . '; charset=' . get_option( 'blog_charset' ) );
  	_wp_admin_html_begin();
  ?>
  <title><?php bloginfo('name') ?> &rsaquo; <?php echo $title ?> &#8212; <?php _e('WordPress'); ?></title>
***************
*** 1430,1436 ****
  $admin_body_class .= ' locale-' . sanitize_html_class( strtolower( str_replace( '_', '-', get_locale() ) ) );
  ?>
  </head>
! <body<?php if ( isset($GLOBALS['body_id']) ) echo ' id="' . $GLOBALS['body_id'] . '"'; ?> class="wp-admin no-js iframe <?php echo apply_filters( 'admin_body_class', '' ) . ' ' . $admin_body_class; ?>">
  <script type="text/javascript">
  //<![CDATA[
  (function(){
--- 1389,1395 ----
  $admin_body_class .= ' locale-' . sanitize_html_class( strtolower( str_replace( '_', '-', get_locale() ) ) );
  ?>
  </head>
! <body<?php if ( isset($GLOBALS['body_id']) ) echo ' id="' . $GLOBALS['body_id'] . '"'; ?> class="wp-admin wp-core-ui no-js iframe <?php echo apply_filters( 'admin_body_class', '' ) . ' ' . $admin_body_class; ?>">
  <script type="text/javascript">
  //<![CDATA[
  (function(){
***************
*** 1631,1649 ****
   *                     Defaults to no other attributes. Other attributes can also be provided as a
   *                     string such as 'tabindex="1"', though the array format is typically cleaner.
   */
! function get_submit_button( $text = null, $type = 'primary', $name = 'submit', $wrap = true, $other_attributes = null ) {
! 	switch ( $type ) :
! 		case 'primary' :
! 		case 'secondary' :
! 			$class = 'button-' . $type;
! 			break;
! 		case 'delete' :
! 			$class = 'button-secondary delete';
! 			break;
! 		default :
! 			$class = $type; // Custom cases can just pass in the classes they want to be used
! 	endswitch;
! 	$text = ( null == $text ) ? __( 'Save Changes' ) : $text;
  
  	// Default the id attribute to $name unless an id was specifically provided in $other_attributes
  	$id = $name;
--- 1590,1612 ----
   *                     Defaults to no other attributes. Other attributes can also be provided as a
   *                     string such as 'tabindex="1"', though the array format is typically cleaner.
   */
! function get_submit_button( $text = null, $type = 'primary large', $name = 'submit', $wrap = true, $other_attributes = null ) {
! 	if ( ! is_array( $type ) )
! 		$type = explode( ' ', $type );
! 
! 	$button_shorthand = array( 'primary', 'small', 'large' );
! 	$classes = array( 'button' );
! 	foreach ( $type as $t ) {
! 		if ( 'secondary' === $t || 'button-secondary' === $t )
! 			continue;
! 		$classes[] = in_array( $t, $button_shorthand ) ? 'button-' . $t : $t;
! 	}
! 	$class = implode( ' ', array_unique( $classes ) );
! 
! 	if ( 'delete' === $type )
! 		$class = 'button-secondary delete';
! 
! 	$text = $text ? $text : __( 'Save Changes' );
  
  	// Default the id attribute to $name unless an id was specifically provided in $other_attributes
  	$id = $name;
***************
*** 1706,1713 ****
  
  		$registered_pointers = array(
  			'index.php'    => 'wp330_toolbar',
! 			'post-new.php' => 'wp330_media_uploader',
! 			'post.php'     => 'wp330_media_uploader',
  			'themes.php'   => array( 'wp330_saving_widgets', 'wp340_customize_current_theme_link' ),
  			'appearance_page_custom-header' => 'wp340_choose_image_from_library',
  			'appearance_page_custom-background' => 'wp340_choose_image_from_library',
--- 1669,1676 ----
  
  		$registered_pointers = array(
  			'index.php'    => 'wp330_toolbar',
! 			'post-new.php' => 'wp350_media',
! 			'post.php'     => 'wp350_media',
  			'themes.php'   => array( 'wp330_saving_widgets', 'wp340_customize_current_theme_link' ),
  			'appearance_page_custom-header' => 'wp340_choose_image_from_library',
  			'appearance_page_custom-background' => 'wp340_choose_image_from_library',
***************
*** 1720,1729 ****
  		$pointers = (array) $registered_pointers[ $hook_suffix ];
  
  		$caps_required = array(
- 			'wp330_media_uploader' => array( 'upload_files' ),
  			'wp330_saving_widgets' => array( 'edit_theme_options', 'switch_themes' ),
  			'wp340_customize_current_theme_link' => array( 'edit_theme_options' ),
  			'wp340_choose_image_from_library' => array( 'edit_theme_options' ),
  		);
  
  		// Get dismissed pointers
--- 1683,1692 ----
  		$pointers = (array) $registered_pointers[ $hook_suffix ];
  
  		$caps_required = array(
  			'wp330_saving_widgets' => array( 'edit_theme_options', 'switch_themes' ),
  			'wp340_customize_current_theme_link' => array( 'edit_theme_options' ),
  			'wp340_choose_image_from_library' => array( 'edit_theme_options' ),
+ 			'wp350_media' => array( 'upload_files' ),
  		);
  
  		// Get dismissed pointers
***************
*** 1758,1764 ****
  	 *
  	 * @param string $pointer_id The pointer ID.
  	 * @param string $selector The HTML elements, on which the pointer should be attached.
! 	 * @param array  $args Arguments to be passed to the pointer JS (see wp-pointer.dev.js).
  	 */
  	private static function print_js( $pointer_id, $selector, $args ) {
  		if ( empty( $pointer_id ) || empty( $selector ) || empty( $args ) || empty( $args['content'] ) )
--- 1721,1727 ----
  	 *
  	 * @param string $pointer_id The pointer ID.
  	 * @param string $selector The HTML elements, on which the pointer should be attached.
! 	 * @param array  $args Arguments to be passed to the pointer JS (see wp-pointer.js).
  	 */
  	private static function print_js( $pointer_id, $selector, $args ) {
  		if ( empty( $pointer_id ) || empty( $selector ) || empty( $args ) || empty( $args['content'] ) )
***************
*** 1815,1829 ****
  	 *
  	 * @since 3.3.0
  	 */
! 	public static function pointer_wp330_media_uploader() {
! 		$content  = '<h3>' . __( 'Updated Media Uploader' ) . '</h3>';
! 		$content .= '<p>' . __( 'The single media icon now launches the uploader for all file types, and the new drag and drop interface makes uploading a breeze.' ) . '</p>';
! 
! 		WP_Internal_Pointers::print_js( 'wp330_media_uploader', '#content-add_media', array(
! 			'content'  => $content,
! 			'position' => array( 'edge' => is_rtl() ? 'right' : 'left', 'align' => 'center' ),
! 		) );
! 	}
  
  	/**
  	 * Print 'New Feature: Saving Widgets' for 3.3.0.
--- 1778,1784 ----
  	 *
  	 * @since 3.3.0
  	 */
! 	public static function pointer_wp330_media_uploader() {}
  
  	/**
  	 * Print 'New Feature: Saving Widgets' for 3.3.0.
***************
*** 1871,1883 ****
  		) );
  	}
  
  	/**
  	 * Prevents new users from seeing existing 'new feature' pointers.
  	 *
  	 * @since 3.3.0
  	 */
  	public static function dismiss_pointers_for_new_users( $user_id ) {
! 		add_user_meta( $user_id, 'dismissed_wp_pointers', 'wp330_toolbar,wp330_media_uploader,wp330_saving_widgets,wp340_choose_image_from_library,wp340_customize_current_theme_link' );
  	}
  }
  
--- 1826,1848 ----
  		) );
  	}
  
+ 	public static function pointer_wp350_media() {
+ 		$content  = '<h3>' . __( 'New Media Manager' ) . '</h3>';
+ 		$content .= '<p>' . __( 'Uploading files and creating image galleries has a whole new look. Check it out!' ) . '</p>';
+ 
+ 		self::print_js( 'wp350_media', '.insert-media', array(
+ 			'content'  => $content,
+ 			'position' => array( 'edge' => is_rtl() ? 'right' : 'left', 'align' => 'center' ),
+ 		) );
+ 	}
+ 
  	/**
  	 * Prevents new users from seeing existing 'new feature' pointers.
  	 *
  	 * @since 3.3.0
  	 */
  	public static function dismiss_pointers_for_new_users( $user_id ) {
! 		add_user_meta( $user_id, 'dismissed_wp_pointers', 'wp330_toolbar,wp330_saving_widgets,wp340_choose_image_from_library,wp340_customize_current_theme_link,wp350_media' );
  	}
  }
  
